/* EEE4084F Lecture 20 Class Activity 

   Implementation of pattern counter

   Handle-C style solution.
*/

void PC (
  _in unsigned* start_input,
  _in unsigned* end_input,
  _in unsigned short pat_input,
  _in bit enable,
  _out bit done,
  _out unsigned short found_out
  )
{
  static bit prev_enable = 0;
  static unsigned short pat;
  static unsigned short found;
  static unsigned* start;
  static unsigned* end;

  if (prev_enable != enable) {
     prev_enable = enable;
     if (enable) {
        pat = pat_input; // store the patter to look for
        start = start_input;
        end = end_input;
        done = 0;
        found = 0;
        return; // the function will immeduately go back to its start when exited
        }
     }
  if (!enable) return;
  // check if we are at the end yet
  if (start == end) {
     found_out = found;
     done = 1; // signal that processing is complete
     return;
  }
  unsigned x = *start;
  if ((x&0xFFFF) == pat) found++; // check low order half word
  if ((x>>16)    == pat) found++; // check high order half word
  start = start + 1; // move on to the next memory address
  // when the function exists, it just goes back to the start
}
